#[cfg(feature="embedded-graphics")]
pub mod embedded_graphics_lib;

#[cfg(feature="smart-leds")]
pub mod smart_leds_lib;

pub mod esp32;

use esp_idf_svc::hal::prelude::Peripherals;

use crate::render::{Output, Surfaces};
use crate::task::Task;

pub trait Board {
    type Output: Output;
    type Surfaces: Surfaces;

    fn new(peripherals: Peripherals) -> Self;
    fn output(&mut self) -> Self::Output;
    fn surfaces(&mut self) -> Self::Surfaces;
    fn system_tasks(&mut self) -> Vec<Box<dyn Task>>;
}